<?php
/*
Plugin Name: Wp Inline Edit
Plugin URI:  http://webgarb.com/wp-inline-edit/
Description: Wp Inline Edit will add ability to author/admin/editor to edit your post/page from page/post itself without going to wp-admin edit page.
Version: 1.2.3
Author: Webgarb
Author URI: http://Webgarb.com
*/
/**
* @package Wp Inline Edit
* @copyright Copyright (c), Ayush Singh [WebGarb.com]
* @license http://www.gnu.org/copyleft/gpl.html
* @author Ayush Singh <contact@webgarb.com>
* @link http://webgarb.com/wp-inline-edit
* @since Monday, August 14, 2012 
*/

define("WP_INLINE_EDIT_VERSION", "1.2.3");
define("WP_INLINE_EDIT_PATH", plugins_url("", __FILE__));
define("WP_INLINE_EDIT_DIR", str_replace("\/", "/", dirname(__FILE__)));

/**
* Loading Scripts
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0
*/
function wp_inline_enqueue_scripts() {
    wp_enqueue_script('jquery'); //Adding jQuery to Header
}
add_action('wp_enqueue_scripts', 'wp_inline_enqueue_scripts'); //Script Hook for wp_inline_enqueue_scripts();


/**
* Load Inline Scripts and CSS on Footer
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0 
*/
function wp_inline_edit_wp_footer() {
    if (!current_user_can('edit_published_posts')) {
        return false;
    } //!current_user_can('edit_published_posts')
    if (is_single() OR is_page()):
?>
	<script type="text/javascript">
	<!--
	jQ = jQuery;

	/* Post Title */
	jQ(".wpined-title").each(function () {
	    jQ(this).parent().attr("href", "javascript:void(0);").find("a").each(function () {
	        jQ(this).attr("href", "javascript:void(0);");
	    });
	    jQ(this).dblclick(function () {
	        ele = jQ(this);
	        wpined_loader("Loading PLease Wait");
	        jQuery.post("<?php
        echo admin_url('admin-ajax.php');
?>", {
	            action: "wp_inline_edit",
	            t: "title",
	            r: "get",
	            postID: jQ(this).attr("rel")
	        },

	        function (d, ele) {
	            wpined_loader_close();
	            jQuery.globalEval(d);
	        });

	    });

	}); //jQ(".wpined-title").each()

	function wpined_title_blur(ele) {


	    jQ(ele).prev("textarea").blur(function () {

	        wpined_loader("Title Saving Please Wait");
	        jQuery.post("<?php
        echo admin_url('admin-ajax.php');
?>", {
	            action: "wp_inline_edit",
	            t: "title",
	            r: "save",
	            postID: jQ(this).next().attr("rel"),
	            content: jQ(this).val(),
	            nonce: jQ("#wp_inline_edit_save").val()
	        },

	        function (d, ele) {
	            wpined_loader_close();
	            jQuery.globalEval(d);
	        });

	    });




	}

	/* Post Content */

	jQ(".wpined-con").dblclick(function () {
	    wpined_loader("Loading Please Wait");
	    jQuery.post("<?php  echo admin_url('admin-ajax.php'); ?>", {
	        action: "wp_inline_edit",
	        t: "content",
	        r: "get",
	        postID: jQ(this).attr("rel")
	    },

	    function (d) {
	        jQuery.globalEval(d);
	        wpined_loader_close();
	        wpined_content_save();

	    });

	});

	function wpined_content_save() {
	    jQ(".wpined-control").remove();
	    jQ("body").append("<div class='wpined-control'><a href=\"javascript:void(0)\" id='#wpined-content-save' class='wpined-button wpined-save'>Save</a><a href=\"javascript:void(0)\" class='wpined-button wpined-cancel'>Cancel</a><div style='clear:both'></div></div>");
	    jQ(".wpined-control").find(".wpined-cancel").click(function () {
	        jQ("#wp_inline_edit_save").remove(); //delete nonce input
	        jQ(".wpined-con").prev().hide(); //Hide Textarea
	        jQ(".wpined-con").show(); //Show old content
	        jQ(".wpined-control").remove(); //Remove Control Bar
	    });
	    fullscreen.save = function () {
	        fullscreen.off();
	        jQ(".wpined-control").find(".wpined-save").click();
	    }; //Full Screenmode trick

	    jQ(".wpined-control").find(".wpined-save").click(function () {
	        jQ("#wpined_textarea-html").click();
	        var temp_con = jQ(this).find("#wpined_textarea").val();
	        jQ("#wpined_textarea-html").click();
	        wpined_loader("Content Saving Please Wait");
	        jQuery.post("<?php echo admin_url('admin-ajax.php'); ?>", {
	            action: "wp_inline_edit",
	            t: "content",
	            r: "save",
	            postID: jQ("#wpined_textarea").attr("data-postid"),
	            content: jQ("#wpined_textarea").val(),
	            nonce: jQ("#wp_inline_edit_save").val()
	        },

	        function (d) {
	            jQuery.globalEval(d);
	            wpined_loader_close();
	        });

	    });


	}

	//keep control bar on bottom
	function wpined_control_bottom() {
	    try {

	        jQ(".wpined-control").animate({
	            "top": jQ(window).scrollTop() + jQ(window).height() - jQ(".wpined-control").height() - 15,
	            "left": jQ(".wpined-con").parent().offset().left,
	            "width": jQ(".wpined-con").parent().width()
	        });
	    } catch (e) {}
	    setTimeout(function () {
	        wpined_control_bottom()
	    }, 500);
	}
	wpined_control_bottom(); //init it
	

	function wpined_loader(m) {
	    if (jQ("#wpined_loader").length == 0) {
	        jQ("body").append('<div id="wpined_loader"> <img src="<?php
        echo WP_INLINE_EDIT_PATH;
?>/images/loader.gif" /><img src="<?php
        echo WP_INLINE_EDIT_PATH;
?>/images/wp-inline-edit_loader.gif" /> <p>' + m + '</p> </div>');
	    }

	    jQ("#wpined_loader").
	    css("top", jQ(window).scrollTop() + (jQ(window).height() / 2) - jQ("#wpined_loader").height() - 20 + "px").
	    css("left", (jQ(window).width() / 2) - (jQ("#wpined_loader").width() / 2) + "px").find("p").html(m);
	    jQ("#wpined_loader").fadeIn();
	}

	function wpined_loader_close() {
	    jQ("#wpined_loader").fadeOut();
	}
	wpined_wrap_did_before = 0;

	function wpined_tmce_position() {
	    try {

	        wpined_tmce_c_po = jQ("#wp-wpined_textarea-wrap").first().offset();
	        wpined_tmce_c = jQ(".mceFirst").first();
	        wpined_scroll = jQ("body").scrollTop();
	        wpined_tool = jQ("#wp-wpined_textarea-editor-tools");
	        wpined_gtool = jQ("#wpined_textarea_toolbargroup");
			wpined_ttool = jQ("#qt_wpined_textarea_toolbar");

	        jQ("#wpined_textarea_toolbargroup").css("width", wpined_tmce_c.width() - 10);
	        jQ("#wp-wpined_textarea-editor-tools").css("width", wpined_tmce_c.width() - 10);
	        if (wpined_ttool.length > 0) { 
	            
				if (jQ("#qt_wpined_textarea_toolbar_inner").length > 0) { } else {
				console.log("done wrap");
	            wpined_ttool.wrapInner("<div id=\"qt_wpined_textarea_toolbar_inner\"></div>");				}
	            
				wpined_ttool.css("padding", "0");
	            wpined_ttool.find("div").css("width", wpined_tmce_c.width() - 10);
	           
			    wpined_ttool.css("height", wpined_tool.height() + wpined_ttool.find("div").height() + 10);
	        }
	        wpined_gtool.parent().css("height", wpined_tool.height() + wpined_gtool.height() + 10);
			
			
	        if (wpined_scroll > wpined_tmce_c_po.top) {
				
				t = wpined_tool.css("top");
				tt = wpined_tool.css("top","0px").offset().top;
				wpined_tool.css("top",t);
	            wpined_tool.stop().animate({
	                "top": wpined_scroll - 0 + 50 - tt
	            });
				
				t = wpined_gtool.css("top");
				tt = wpined_gtool.css("top","0px").offset().top;
				wpined_gtool.css("top",t);
	            wpined_gtool.stop().animate({
	                "top": wpined_scroll + 60 + wpined_tool.height() - tt
	            });
				
				t = wpined_ttool.css("top");
				tt = wpined_ttool.css("top","0px").offset().top;
				wpined_ttool.css("top",t);
	            wpined_ttool.stop().find("div").animate({
	                "top": wpined_scroll + 60 + wpined_tool.height() - tt
	            });
	            //console.log("run1 "+ wpined_scroll +" - "+ wpined_tmce_c_po);
	        } else {
				
				t = wpined_gtool.css("top");
				tt = wpined_gtool.css("top","0px").offset().top;
				wpined_gtool.css("top",t);
	            wpined_gtool.stop().animate({
	                "top": wpined_tmce_c_po.top + wpined_tool.height() + 10 - tt
	            });
				
				t = wpined_ttool.css("top");
				tt = wpined_ttool.css("top","0px").offset().top;
				wpined_ttool.css("top",t);
	            wpined_ttool.find("div").stop().animate({
	                "top": wpined_tmce_c_po.top + wpined_tool.height() + 10 - tt
	            });
				
				t = wpined_tool.css("top");
				tt = wpined_tool.css("top","0px").offset().top;
				wpined_tool.css("top",t);
	            wpined_tool.stop().animate({
	                "top": wpined_tmce_c_po.top - tt
	            });
	            //console.log("run2 "+ wpined_scroll +" - "+ wpined_tmce_c_po);
	        }

	    } catch (e) {}

	    setTimeout(function () {
	        wpined_tmce_position();
	    }, 500);
	}
	wpined_tmce_position();
	/*	
	 * jQuery autoResize (textarea auto-resizer)
	 * @copyright James Padolsey http://james.padolsey.com
	 * @version 1.04
	 */

	 (function (a) {
	    a.fn.autoResize = function (j) {
	        var b = a.extend({
	            onResize: function () {},
	            animate: true,
	            animateDuration: 150,
	            animateCallback: function () {},
	            extraSpace: 20,
	            limit: 1000
	        }, j);
	        this.filter('textarea').each(function () {
	            var c = a(this).css({
	                resize: 'none',
	                'overflow-y': 'hidden'
	            }),
	                k = c.height(),
	                f = (function () {
	                    var l = ['height', 'width', 'lineHeight', 'textDecoration', 'letterSpacing'],
	                        h = {};
	                    a.each(l, function (d, e) {
	                        h[e] = c.css(e)
	                    });
	                    return c.clone().removeAttr('id').removeAttr('name').css({
	                        position: 'absolute',
	                        top: 0,
	                        left: -9999
	                    }).css(h).attr('tabIndex', '-1').insertBefore(c)
	                })(),
	                i = null,
	                g = function () {
	                    f.height(0).val(a(this).val()).scrollTop(10000);
	                    var d = Math.max(f.scrollTop(), k) + b.extraSpace,
	                        e = a(this).add(f);
	                    if (i === d) {
	                        return
	                    }
	                    i = d;
	                    if (d >= b.limit) {
	                        a(this).css('overflow-y', '');
	                        return
	                    }
	                    b.onResize.call(this);
	                    b.animate && c.css('display') === 'block' ? e.stop().animate({
	                        height: d
	                    }, b.animateDuration, b.animateCallback) : e.height(d)
	                };
	            c.unbind('.dynSiz').bind('keyup.dynSiz', g).bind('keydown.dynSiz', g).bind('change.dynSiz', g)
	        });
	        return this
	    }
	})(jQuery);
	//-->
	</script>
	
	<style type="text/css">
	.wpined-parent {
	    font-size: inherit !important;
	    font-family: inherit !important;
	    font: inherit !important;
	    color: inherit !important;
	    background-color: transparent !important;
	    border: none !important;
	    border-color: none !important;
	    display: none;
	    line-height: inherit;
	    margin: 0px;
	    padding: 0px;
	    outline: none;
	    background: none!important;
	}
	
	#wpined_loader {
	    background: white;
	    -webkit-border-radius: 10px;
	    border-radius: 10px;
	    -webkit-box-shadow: 0px 0px 10px 4px #646464;
	    box-shadow: 0px 0px 10px 4px #646464;
	    position: absolute;
	    z-index: 150015;
	    padding: 20px;
	    text-align: center;
	}
	
	#wpined_loader p {
	    padding-top: 5px;
	}
	
	.wpined_tip {
	    -webkit-border-radius: 8px;
	    border-radius: 8px;
	    background: #ffe42d;
	    padding: 0px;
	    width: 250px;
	    margin: auto;
	    margin-bottom: 2px;
	    border-width: 1px;
	    border-style: solid;
	    border-color: #b1a00c;
	    color: #b1a00c;
	    text-align: center;
	    font-size: 12px;
	    line-height: 18px;
	}
	
	.wpined_textarea {
	    border-style: dashed;
	    border-width: 1px;
	    outline: none;
	    border-color: #aaaaaa;
		overflow:hidden;
	}
	.wpined-control {
	background:#dbdbdb;
	padding:4px;
	position:absolute;
	z-index:15015;
	}
	.wpined-button {
		width:100px;
		color:white!important;
		background:green!important;
		text-align:center;
		padding:2px;
		font-size:13px!important;
		display:block;
		text-decoration:none;
		float:left;
		margin-left:2px;
		margin-right:2px;
		text-transform:uppercase;
		-webkit-border-radius: 6px;
		border-radius: 6px;
	}
	.wpined-save {
		color:white!important;
		background:green!important;
	}
	.wpined-cancel {
		color:white!important;
		background:#ff3338!important;
	}
	.wp-editor-container {
		border-style: dashed;
	    border-width: 1px;
	    outline: none;
	    border-color: #aaaaaa;
	}
	#wp-wpined_textarea-wrap {
		display:none;
	}

	#wp-wpined_textarea-wrap tr,#wp-wpined_textarea-wrap td,#wp-wpined_textarea-wrap tr td,#wp-wpined_textarea-wrap table {
		padding:0px !important;
		margin:0px !important;
		border:none !important;
		font-size:12px !important;
		background:transparent !important;
	}
	#wp-wpined_textarea-wrap input{ 
		font-size:12px !important;
	}
	.mceStatusbar  {
		overflow:hidden;
		height:1px;
		background:transparent !important;
	}
	.mceToolbar ,#qt_wpined_textarea_toolbar,#wpined_textarea {
		background:transparent !important;
	}
	#wpined_textarea_toolbargroup,#wp-wpined_textarea-editor-tools,#qt_wpined_textarea_toolbar div {
		position:absolute;
		z-index:99;
		background-color:#E9E9E9;
		padding:5px;

	}
	</style>
	<?php
    endif;
}

add_action("wp_footer", "wp_inline_edit_wp_footer"); //Wp Footer Hook for wp_inline_edit_wp_footer();

/**
* Filter Post Content
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0
* @param string $content
*/
function wp_inline_edit_the_content($content) {
    if (!wp_inline_edit_parent_exists("the_content")) {
        return $content;
    } //!wp_inline_edit_parent_exists("the_content")
    if (!in_the_loop()) {
        return $title;
    } //!in_the_loop()
    
    if (!current_user_can('edit_published_posts')) {
        return $content;
    } //!current_user_can('edit_published_posts')
    if (is_single() OR is_page()):
        global $post;
        
        $return = wp_inline_edit_get_editor('');
        $return .= '<span class="wpined-con" rel="' . $post->ID . '">';
        $return .= $content;
        $return .= '</span>';
        global $temp_ID;
        echo $temp_ID;
        return $return;
    else:
        return $content;
    endif;
}
add_filter("the_content", "wp_inline_edit_the_content"); //The Content Hook for wp_inline_edit_the_content()

/**
* Filter Post Title 
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0
* @param string $title
*/
function wp_inline_edit_the_title($title) {
    if (!wp_inline_edit_parent_exists("the_title")) {
        return $title;
    } //!wp_inline_edit_parent_exists("the_title")
    if (!in_the_loop()) {
        return $title;
    } //!in_the_loop()
    
    if (!current_user_can('edit_published_posts')) {
        return $title;
    } //!current_user_can('edit_published_posts')
    if (is_single() OR is_page()):
        global $post;
        $return = '<span class="wpined-title" rel="' . $post->ID . '">';
        $return .= $title;
        $return .= '</span>';
        return $return;
    else:
        return $title;
    endif;
}
add_filter("the_title", "wp_inline_edit_the_title"); //The Title Hook for wp_inline_edit_the_title()

/**
* Ajax Stuff 
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0 
*/
function wp_inline_edit_ajax() {
    $postID = intval($_POST["postID"]);
    if (empty($postID)) {
        return false;
    } //empty($postID)
    if (!current_user_can('edit_post', $postID)) { //only post author can edit
        return false;
    } //!current_user_can('edit_post', $postID)
    if ($_POST["t"] == "title") {
        if ($_POST["r"] == "get") {
            $post_details = wp_get_single_post($postID);
            $js_title     = $post_details->post_title;
            $js_title     = wp_inline_edit_strip_newline($js_title, ' ');
            $js_title     = str_replace('"', '\"', $js_title);
            $wp_nonce     = wp_nonce_field('wp_inline_edit_title', 'wp_inline_edit_save', false, false);
            $wp_nonce     = str_replace("
", "", $wp_nonce);
            $wp_nonce     = str_replace('"', '\"', $wp_nonce);
            echo '
	
	jQ(ele).before("' . $wp_nonce . '");
	jQ(ele).before("<textarea class=\"wpined_textarea\">");
	var inpt = jQ(ele).prev("textarea");
	var pt = jQ(ele).parent();
	inpt.val("' . $js_title . '");
	inpt.css("width",pt.width())
	inpt.css("height",jQ(ele).height()+"px")
	.css("font-size",pt.css("font-size"))
	.css("background-color","transparent")
	.css("font-family",pt.css("font-family"))
	.css("color",pt.css("color"))
	//.css("border","none")
	.css("box-shadow","none")
	.before("<div class=\"wpined_tip\" id=\"wpined_tip\">Click Outside to Save After You Done.</div>");
	setTimeout(function() { jQ("#wpined_tip").fadeOut(function() { jQ(this).remove(); })},2000);
	
	inpt.focus().bind("keydown keypress keyup",function() {
	jQ(this).css("height",jQ(ele).height())
	.css("height",jQ(this).get(0).scrollHeight);
	});
	
	jQ(ele).hide();
	wpined_title_blur(ele);
	';
            
        } //$_POST["r"] == "get"
        
        if ($_POST["r"] == "save") {
            if (wp_verify_nonce($_POST['nonce'], 'wp_inline_edit_title')) {
                wp_update_post(array(
                    "ID" => $_POST["postID"],
                    "post_title" => $_POST["content"]
                ));
            } //wp_verify_nonce($_POST['nonce'], 'wp_inline_edit_title')
            
            $post_details = wp_get_single_post($postID);
            $post_title   = apply_filters("the_title", $post_details->post_title);
            $post_title   = wp_inline_edit_strip_newline($post_title, ' ');
            $post_title   = str_replace('"', '\"', $post_title);
            echo ' 
		jQ(".wpined-title").each(function() {
		jQ(this).prev("textarea").remove();
		jQ("#wp_inline_edit_save").remove();
		jQ(this).html("' . $post_title . '");
		jQ(this).show();
		});
		';
            
            exit;
        } //$_POST["r"] == "save"
        
        
    } //$_POST["t"] == "title"
    elseif ($_POST["t"] == "content") {
        if ($_POST["r"] == "get") {
            $post_details = wp_get_single_post($postID);
            $js_content   = $post_details->post_content;
            $js_content   = wp_inline_edit_strip_newline($js_content, '\\n');
            $js_content   = str_replace('"', '\"', $js_content);
            $wp_nonce     = wp_nonce_field('wp_inline_edit_content', 'wp_inline_edit_save', false, false);
            $wp_nonce     = wp_inline_edit_strip_newline($wp_nonce, '');
            $wp_nonce     = str_replace('"', '\"', $wp_nonce);
            echo '
	jQ(".wpined-con").each(function() {
	var inpt = jQ(this).prev().show().find("#wpined_textarea");
	jQ(this).prev().find("#wpined_textarea-html").click();
	inpt.val("' . $js_content . '").attr("data-postid","' . $postID . '");
	jQ(this).prev().find("#wpined_textarea-tmce").click(); //turn HTML Mode
	jQ(this).before("' . $wp_nonce . '");
	//inpt.autoResize().focus().keydown();
	jQ(this).hide();
	});
	';
            
        } //$_POST["r"] == "get"
        
        if ($_POST["r"] == "save") {
            if (wp_verify_nonce($_POST['nonce'], 'wp_inline_edit_content')) {
                wp_update_post(array(
                    "ID" => $_POST["postID"],
                    "post_content" => $_POST["content"]
                ));
            } //wp_verify_nonce($_POST['nonce'], 'wp_inline_edit_content')
            
            $post_details = wp_get_single_post($postID);
            $post_content = apply_filters("the_content", $post_details->post_content);
            $post_content = wp_inline_edit_strip_newline($post_content, '\\n');
            $post_content = str_replace('"', '\"', $post_content);
            echo ' 
		jQ(".wpined-con").each(function() {
		jQ(this).html("' . $post_content . '");
		jQ(this).show();
		});
		jQ(".wpined-control").find(".wpined-cancel").click();
		';
            
            exit;
        } //$_POST["r"] == "save"
        
        
    } //$_POST["t"] == "content"
    exit;
    
}
add_action("wp_ajax_wp_inline_edit", "wp_inline_edit_ajax"); //Ajax Hook for wp_inline_edit action

/**
* Function for checking if the function was evaluate in parent of current action.
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0
* @param string $func
* @return bool
*/
function wp_inline_edit_parent_exists($func) {
    $array = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
    foreach ($array as $a) {
        $aa[] = $a["function"];
    } //$array as $a
    if (in_array($func, $aa)) {
        return true;
    } //in_array($func, $aa)
    return false;
}

/**
* Runs When Plugin gets deactivated
* @author Ayush Singh <contact@webgarb.com>
* @since 1.0
*/
function wp_inline_edit_register_deactivation_hook() {
    update_option("wp_inline_edit_install", "");
}
register_deactivation_hook(__FILE__, 'wp_inline_edit_register_deactivation_hook');

//Code runs when plugin gets activate and throw a message on wordpress admin.
if (get_option("wp_inline_edit_install") == "") {
    add_action('admin_notices', create_function("", '
	echo \'<br /><p><center> <a href="http://webgarb.com/wp-inline-edit/" target="_blank"><img src="' . WP_INLINE_EDIT_PATH . '/images/logo.png" alt="Logo" /></a></center><center><br /><h3>Thanks for installing <a href="http://webgarb.com/wp-inline-edit/" target="_blank">WP Inline Edit</a></h3><p>Have a happy editing :)</p></center></p>\';
	update_option("wp_inline_edit_install","1");
	'));
} //get_option("wp_inline_edit_install") == ""

/**
* Removing/Filtering New line
* @param string $c
* @param string $r
* @since 1.2 
*/
function wp_inline_edit_strip_newline($c, $r) {
    return preg_replace('~[\r\n]+~', $r, $c);
}

/**
* Return Wp_editor in string
* @author Ayush Singh <contact@webgarb.com>
* @param string $c
* @param string $r
* @since 1.2 
*/
function wp_inline_edit_get_editor($content) {
    global $post;
    ob_start();
    wp_editor($content, 'wpined_textarea', array(
        "dfw" => true
    ));
    $html = ob_get_clean();
    $html = str_replace("post_id=0", "post_id=" . $post->ID, $html); //Trick for media button
    return $html;
}
/**
* Adding Custom TinyMce Plugin for Wp Editor for making Wp Inline Edit Awesome :)
* @author Ayush Singh <contact@webgarb.com>
* @since 1.2
*/
function wp_inline_edit_tmce_plugin($plugin_array) {
	if (is_single() OR is_page()):
    $plugin_array['autohresize'] = WP_INLINE_EDIT_PATH . '/js/autoresize.js';
    return $plugin_array;
	endif;
}
add_filter("mce_external_plugins", "wp_inline_edit_tmce_plugin"); //Hook for wp_inline_edit_tmce_plugin()

?>